from .util import Choices


genremap = [
    ((0x0, 'ニュース／報道'), [
        (0x0, '定時・総合'),
        (0x1, '天気'),
        (0x2, '特集・ドキュメント'),
        (0x3, '政治・国会'),
        (0x4, '経済・市況'),
        (0x5, '海外・国際'),
        (0x6, '解説'),
        (0x7, '討論・会談'),
        (0x8, '報道特番'),
        (0x9, 'ローカル・地域'),
        (0xA, '交通'),
        (0xF, 'その他')]),
    ((0x1, 'スポーツ'), [
        (0x0, 'スポーツニュース'),
        (0x1, '野球'),
        (0x2, 'サッカー'),
        (0x3, 'ゴルフ'),
        (0x4, 'その他の球技'),
        (0x5, '相撲・格闘技'),
        (0x6, 'オリンピック・国際大会'),
        (0x7, 'マラソン・陸上・水泳'),
        (0x8, 'モータースポーツ'),
        (0x9, 'マリン・ウィンタースポーツ'),
        (0xA, '競馬・公営競技'),
        (0xF, 'その他')]),
    ((0x2, '情報／ワイドショー'), [
        (0x0, '芸能・ワイドショー'),
        (0x1, 'ファッション'),
        (0x2, '暮らし・住まい'),
        (0x3, '健康・医療'),
        (0x4, 'ショッピング・通販'),
        (0x5, 'グルメ・料理'),
        (0x6, 'イベント'),
        (0x7, '番組紹介・お知らせ'),
        (0xF, 'その他')]),
    ((0x3, 'ドラマ'), [
        (0x0, '国内ドラマ'),
        (0x1, '海外ドラマ'),
        (0x2, '時代劇'),
        (0xF, 'その他')]),
    ((0x4, '音楽'), [
        (0x0, '国内ロック・ポップス'),
        (0x1, '海外ロック・ポップス'),
        (0x2, 'クラシック・オペラ'),
        (0x3, 'ジャズ・フュージョン'),
        (0x4, '歌謡曲・演歌'),
        (0x5, 'ライブ・コンサート'),
        (0x6, 'ランキング・リクエスト'),
        (0x7, 'カラオケ・のど自慢'),
        (0x8, '民謡・邦楽'),
        (0x9, '童謡・キッズ'),
        (0xA, '民族音楽・ワールドミュージック'),
        (0xF, 'その他')]),
    ((0x5, 'バラエティ'), [
        (0x0, 'クイズ'),
        (0x1, 'ゲーム'),
        (0x2, 'トークバラエティ'),
        (0x3, 'お笑い・コメディ'),
        (0x4, '音楽バラエティ'),
        (0x5, '旅バラエティ'),
        (0x6, '料理バラエティ'),
        (0xF, 'その他')]),
    ((0x6, '映画'), [
        (0x0, '洋画'),
        (0x1, '邦画'),
        (0x2, 'アニメ'),
        (0xF, 'その他')]),
    ((0x7, 'アニメ／特撮'), [
        (0x0, '国内アニメ'),
        (0x1, '海外アニメ'),
        (0x2, '特撮'),
        (0xF, 'その他')]),
    ((0x8, 'ドキュメンタリー／教養'), [
        (0x0, '社会・時事'),
        (0x1, '歴史・紀行'),
        (0x2, '自然・動物・環境'),
        (0x3, '宇宙・科学・医学'),
        (0x4, 'カルチャー・伝統文化'),
        (0x5, '文学・文芸'),
        (0x6, 'スポーツ'),
        (0x7, 'ドキュメンタリー全般'),
        (0x8, 'インタビュー・討論'),
        (0xF, 'その他')]),
    ((0x9, '劇場／公演'), [
        (0x0, '現代劇・新劇'),
        (0x1, 'ミュージカル'),
        (0x2, 'ダンス・バレエ'),
        (0x3, '落語・演芸'),
        (0x4, '歌舞伎・古典'),
        (0xF, 'その他')]),
    ((0xA, '趣味／教育'), [
        (0x0, '旅・釣り・アウトドア'),
        (0x1, '園芸・ペット・手芸'),
        (0x2, '音楽・美術・工芸'),
        (0x3, '囲碁・将棋'),
        (0x4, '麻雀・パチンコ'),
        (0x5, '車・オートバイ'),
        (0x6, 'コンピュータ・ＴＶゲーム'),
        (0x7, '会話・語学'),
        (0x8, '幼児・小学生'),
        (0x9, '中学生・高校生'),
        (0xA, '大学生・受験'),
        (0xB, '生涯教育・資格'),
        (0xC, '教育問題'),
        (0xF, 'その他')]),
    ((0xB, '福祉'), [
        (0x0, '高齢者'),
        (0x1, '障害者'),
        (0x2, '社会福祉'),
        (0x3, 'ボランティア'),
        (0x4, '手話'),
        (0x5, '文字（字幕）'),
        (0x6, '音声解説'),
        (0xF, 'その他')])]


class Genre(object):
    def __init__(self, large, medium):
        self.code = '%02d%02d' % (large[0], medium[0])
        self.name = '%s(%s)' % (large[1], medium[1])

code_map = {}
name_map = {}
for large, mediums in genremap:
    for medium in mediums:
        genre = Genre(large, medium)
        code_map[genre.code] = genre
        name_map[genre.name] = genre

GenreChoices = Choices(Genre, code_map, name_map)
